diff --git a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
index 18eb91e5d..a5002e1af 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
@@ -149,7 +149,8 @@ public class DataDumper implements MinecraftAccessor {
                 .append(String.format("0x%06X", biome.color)).append(",")
                 .append(Blocks.blocksList[biome.topBlock].getKey()).append(",")
                 .append(Blocks.blocksList[biome.fillerBlock].getKey()).append(",")
-                .append(biome.hasSurfaceSnow()).append(",");
+                .append(biome.hasSurfaceSnow()).append(",")
+                .append(biome.hasSurfaceIce()).append(",");
 
         builder.append("\"");
 
diff --git a/game/client/src/main/java/net/minecraft/client/GLAllocation.java b/game/client/src/main/java/net/minecraft/client/GLAllocation.java
index 167988eb1..9c33e6719 100644
--- a/game/client/src/main/java/net/minecraft/client/GLAllocation.java
+++ b/game/client/src/main/java/net/minecraft/client/GLAllocation.java
@@ -1,35 +1,28 @@
 package net.minecraft.client;
 
 import java.nio.*;
-import java.util.ArrayList;
-import java.util.List;
 
 import it.unimi.dsi.fastutil.ints.IntArrayList;
 import it.unimi.dsi.fastutil.ints.IntList;
+import org.lwjgl.BufferUtils;
 import org.lwjgl.opengl.GL11;
 
 public class GLAllocation {
 
-	public static IntList displayLists = new IntArrayList();
+//	public static IntList displayLists = new IntArrayList();
 	public static IntList textureNames = new IntArrayList();
 
 	public GLAllocation() {}
 
+	@Deprecated
 	public static synchronized int generateDisplayLists(int range) {
-		int list = GL11.glGenLists(range);
-		displayLists.add(list);
-		displayLists.add(range);
-		return list;
+//		int list = GL11.glGenLists(range);
+//		displayLists.add(list);
+//		displayLists.add(range);
+//		return list;
+		return 0;
 	}
 
-	public static synchronized void generateTextureNames(IntBuffer intbuffer) {
-		GL11.glGenTextures(intbuffer);
-		for (int i = intbuffer.position(); i < intbuffer.limit(); i++) {
-			textureNames.add(intbuffer.get(i));
-		}
-
-	}
-	
 	public static synchronized int generateTexture() {
 		int tex = GL11.glGenTextures();
 		textureNames.add(tex);
@@ -46,42 +39,29 @@ public class GLAllocation {
 		}
 	}
 
+	@Deprecated
 	public static synchronized void deleteDisplayList(int displayList)
 	{
-		int displayListIndex = displayLists.indexOf(displayList);
-		if (displayListIndex < 0) return;
-		GL11.glDeleteLists(displayLists.getInt(displayListIndex), displayLists.getInt(displayListIndex + 1));
-		displayLists.removeInt(displayListIndex);
-		displayLists.removeInt(displayListIndex);
+//		int displayListIndex = displayLists.indexOf(displayList);
+//		if (displayListIndex < 0) return;
+//		GL11.glDeleteLists(displayLists.getInt(displayListIndex), displayLists.getInt(displayListIndex + 1));
+//		displayLists.removeInt(displayListIndex);
+//		displayLists.removeInt(displayListIndex);
 	}
 
 	public static synchronized void deleteTexturesAndDisplayLists() {
-		for (int i = 0; i < displayLists.size(); i += 2) {
-			GL11.glDeleteLists(displayLists.getInt(i), displayLists.getInt(i + 1));
-		}
+//		for (int i = 0; i < displayLists.size(); i += 2) {
+//			GL11.glDeleteLists(displayLists.getInt(i), displayLists.getInt(i + 1));
+//		}
 
-		IntBuffer intbuffer = createDirectIntBuffer(textureNames.size());
+		IntBuffer intbuffer = BufferUtils.createIntBuffer(textureNames.size());
 		for (Integer textureName : textureNames) {
 			intbuffer.put(textureName);
 		}
 
 		intbuffer.flip();
 		GL11.glDeleteTextures(intbuffer);
-		displayLists.clear();
+//		displayLists.clear();
 		textureNames.clear();
 	}
-
-	public static synchronized ByteBuffer createDirectByteBuffer(int i) {
-		ByteBuffer bytebuffer = ByteBuffer.allocateDirect(i).order(ByteOrder.nativeOrder());
-		return bytebuffer;
-	}
-
-	public static IntBuffer createDirectIntBuffer(int i) {
-		return createDirectByteBuffer(i << 2).asIntBuffer();
-	}
-
-	public static FloatBuffer createDirectFloatBuffer(int i) {
-		return createDirectByteBuffer(i << 2).asFloatBuffer();
-	}
-
 }
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index c29583770..0031d1dff 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -1,7 +1,5 @@
 package net.minecraft.client;
 
-import static org.lwjgl.opengl.GL11.*;
-
 import java.awt.Cursor;
 import java.awt.event.MouseAdapter;
 import java.awt.event.MouseEvent;
@@ -34,10 +32,14 @@ import net.minecraft.client.gui.server.ScreenSelectServer;
 import net.minecraft.client.gui.toasts.GuiElementToastsHud;
 import net.minecraft.client.holiday.Holidays;
 import net.minecraft.client.player.controller.PlayerControllerSP;
+import net.minecraft.client.render.renderer.CompareFunc;
+import net.minecraft.client.render.renderer.CullFace;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.world.chunk.provider.ChunkProviderDynamic;
 import net.minecraft.client.world.chunk.provider.ChunkProviderThreadedClient;
 import net.minecraft.client.world.save.SaveHandlerClientSP;
-import net.minecraft.core.net.CertificateHelper;
 import net.minecraft.client.net.handler.PacketHandlerClient;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.block.model.BlockModelGrass;
@@ -102,13 +104,13 @@ import net.minecraft.client.sound.SoundRepository;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import org.joml.Matrix4f;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 import org.lwjgl.LWJGLException;
 import org.lwjgl.glfw.GLFW;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
@@ -130,8 +132,6 @@ import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.player.controller.PlayerController;
 import net.minecraft.client.render.ParticleEngine;
-import net.minecraft.client.render.FallbackRenderer;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.LoadingScreenRenderer;
 import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.client.render.PostProcessingManager;
@@ -144,12 +144,10 @@ import net.minecraft.client.render.camera.EntityCameraFirstPerson;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
-import net.minecraft.client.render.shader.Shaders;
 import net.minecraft.client.render.shader.ShadersRenderer;
 import net.minecraft.client.render.terrain.ChunkRenderer;
 import net.minecraft.client.render.terrain.TerrainRenderer;
-import net.minecraft.client.render.terrain.TerrainRendererLegacy;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.client.render.window.GameWindow;
@@ -204,6 +202,7 @@ import net.minecraft.core.world.save.LevelStorage;
 import net.minecraft.core.world.save.SaveConverters;
 import net.minecraft.core.world.save.SaveFormats;
 import net.minecraft.core.world.save.mcregion.SaveFormat19134;
+import org.lwjgl.opengl.GL41;
 import org.lwjgl.system.Configuration;
 import org.slf4j.Logger;
 import org.useless.dragonfly.data.entity.mojang.EntityGeometryMojangData;
@@ -222,7 +221,7 @@ public class Minecraft
     public PlayerController playerController;
     public boolean hasCrashed;
     public UnexpectedThrowable lastCrash;
-    private final Timer timer;
+    public final Timer timer;
     public WorldClient currentWorld;
     public RenderGlobal renderGlobal;
     public PlayerLocal thePlayer;
@@ -344,11 +343,11 @@ public class Minecraft
         this.guiToasts = new GuiElementToastsHud(this);
         this.sndManager = new SoundEngine();
 
-        try {
-            CertificateHelper.installCertificates();
-        } catch (Exception e) {
-            LOGGER.error("Failed to install certificates!", e);
-        }
+//        try {
+//            CertificateHelper.installCertificates();
+//        } catch (Exception e) {
+//            LOGGER.error("Failed to install certificates!", e);
+//        }
 
         new Thread("Timer hack thread") {
             {
@@ -505,14 +504,11 @@ public class Minecraft
         printWrongJavaVersionInfo();
 
         this.gameWindow.init(this, this.overrideWidth != null ? this.overrideWidth : this.gameSettings.windowWidth.value, this.overrideHeight != null ? this.overrideHeight : this.gameSettings.windowHeight.value);
+        this.font.init();
 
-        final @Nullable String vendorString = GL11.glGetString(GL_VENDOR);
+        final @Nullable String vendorString = GL41.glGetString(GL41.GL_VENDOR);
         if (vendorString != null) {
             GPU_VENDOR = EnumGPUVendor.getVendorFromString(vendorString);
-            if (GPU_VENDOR == EnumGPUVendor.INTEL) {
-                // Intel cannot handle the sheer complexity of drawing the lightmap texture upon a quad
-                this.gameSettings.lightmapStyle.set(LightmapStyle.DISABLED);
-            }
         }
 
         LOGGER.info("Resolution: {} x {}", this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels());
@@ -530,26 +526,10 @@ public class Minecraft
 
         this.resolution.setScale(this.gameSettings.guiScale.value);
 
-        OpenGLHelper.testCapabilities(this);
-
-        if (this.gameSettings.enableMultiDrawRendering.value) {
-            if (OpenGLHelper.gl20) {
-                LOGGER.info("Using MultiDraw terrain renderer");
-                this.terrainRenderer = new TerrainRendererMultiDraw(this);
-            } else {
-                LOGGER.info("MultiDraw not supported, using legacy terrain renderer");
-                this.terrainRenderer = new TerrainRendererLegacy(this);
-            }
-        } else {
-            LOGGER.info("MultiDraw disabled, using legacy terrain renderer");
-            this.terrainRenderer = new TerrainRendererLegacy(this);
-        }
+        this.terrainRenderer = new TerrainRendererMultiDraw(this);
 
-        if (Shaders.enableShaders) {
-            setRenderer(new ShadersRenderer(this));
-        } else {
-            setRenderer(new FallbackRenderer(this));
-        }
+        setRenderer(new ShadersRenderer(this));
+        Shaders.init();
 
         this.texturePackList.init();
         EntityGeometryMojangData.Cache.reload(this.texturePackList);
@@ -557,6 +537,8 @@ public class Minecraft
         TooltipElement.reloadStyles(this.texturePackList);
         SoundRepository.initialize(this);
 
+        GLRenderer.init();
+
         // Show load screen as early as possible
         // Do not put stuff that takes a while to load before this,
         // otherwise the loading time will happen while the window is black
@@ -589,17 +571,16 @@ public class Minecraft
         LOGGER.info("Setting up OpenGL values...");
 
         OpenGLHelper.checkError("pre startup");
-        glEnable(GL11.GL_TEXTURE_2D);
-        glShadeModel(GL11.GL_SMOOTH);
-        glClearDepth(1.0D);
-        glEnable(GL11.GL_DEPTH_TEST);
-        glDepthFunc(515);
-        glEnable(GL11.GL_ALPHA_TEST);
-        glAlphaFunc(516, 0.1F);
-        glCullFace(GL11.GL_BACK);
-        glMatrixMode(GL11.GL_PROJECTION);
-        glLoadIdentity();
-        glMatrixMode(GL11.GL_MODELVIEW);
+//        glEnable(GL11.GL_TEXTURE_2D);
+//        glShadeModel(GL11.GL_SMOOTH);
+        GL41.glClearDepth(1.0D);
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL);
+//        glEnable(GL11.GL_ALPHA_TEST);
+//        glAlphaFunc(GL11.GL_GREATER, 0.1F);
+        GLRenderer.setCullFace(CullFace.BACK);
+        GLRenderer.projectionM4f().identity();
+        GLRenderer.viewM4f().identity();
         OpenGLHelper.checkError("startup");
         this.sndManager.init(this.gameSettings);
 
@@ -615,9 +596,9 @@ public class Minecraft
 
         LOGGER.info("Initializing Renderer...");
 
-        TextureRegistry.blockAtlas.bind();
+        TextureRegistry.worldAtlas.bind();
         this.renderGlobal = new RenderGlobal(this, this.textureManager);
-        glViewport(0, 0, this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels());
+        GL41.glViewport(0, 0, this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels());
         this.particleEngine = new ParticleEngine(this.currentWorld);
         try {
             LOGGER.info("Starting Resource Download Thread...");
@@ -646,8 +627,8 @@ public class Minecraft
         int groups = Registries.RECIPES.getAllGroups().size();
         int namespaces = Registries.RECIPES.size();
         int itemGroups = Registries.ITEM_GROUPS.size();
-        LOGGER.info(String.format("%d item groups.", itemGroups));
-        LOGGER.info(String.format("%d recipes in %d groups in %d namespaces.", recipes, groups, namespaces));
+        LOGGER.info("{} item groups.", itemGroups);
+        LOGGER.info("{} recipes in {} groups in {} namespaces.", recipes, groups, namespaces);
 
         StatList.init();
         this.statsCounter = new StatsCounter(this.session, this.mcDataDir);
@@ -761,60 +742,66 @@ public class Minecraft
         }
     }
 
+    public @NotNull Matrix4f getGuiProjectionMatrix(@NotNull Matrix4f dest) {
+        return dest.identity().ortho(0.0f, (float) this.resolution.getExactScaledWidthScreenCoords(), (float) this.resolution.getExactScaledHeightScreenCoords(), 0.0f, 1000f, 3000f);
+    }
+
+    public @NotNull Matrix4f getGuiViewMatrix(@NotNull Matrix4f dest) {
+        return dest.identity().translate(0, 0, -2000);
+    }
+
     private void loadScreen() throws LWJGLException {
-        LOGGER.info("Drawing Loading Screen...");
-        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
-        glMatrixMode(GL11.GL_PROJECTION);
-        glLoadIdentity();
-        glOrtho(0.0D, this.resolution.getExactScaledWidthScreenCoords(), this.resolution.getExactScaledHeightScreenCoords(), 0.0D, 1000D, 3000D);
-        glMatrixMode(GL11.GL_MODELVIEW);
-        glLoadIdentity();
-        glTranslatef(0.0F, 0.0F, -2000F);
-        glViewport(0, 0, this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels());
-        glClearColor(0.0F, 0.0F, 0.0F, 0.0F);
-        Tessellator tessellator = Tessellator.instance;
-        glDisable(GL11.GL_LIGHTING);
-        glEnable(GL11.GL_TEXTURE_2D);
-        glDisable(GL11.GL_FOG);
-
-        if (this.mojrand == 0)
+//        LOGGER.info("Drawing Loading Screen...");
+        GL41.glClear(GL41.GL_COLOR_BUFFER_BIT | GL41.GL_DEPTH_BUFFER_BIT);
+        getGuiProjectionMatrix(GLRenderer.projectionM4f());
+        getGuiViewMatrix(GLRenderer.viewM4f());
+        GL41.glViewport(0, 0, this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels());
+        GL41.glClearColor(0.0F, 0.0F, 0.0F, 0.0F);
+
+//        glDisable(GL11.GL_LIGHTING);
+//        glEnable(GL11.GL_TEXTURE_2D);
+//        glDisable(GL11.GL_FOG);
+
+        if (this.mojrand == 0) {
             this.textureManager.loadTexture("/assets/minecraft/textures/gui/title/majonk.png").bind();
-        else
+        }
+        else {
             this.textureManager.loadTexture("/assets/minecraft/textures/gui/title/mojang.png").bind();
+        }
 
-        tessellator.startDrawingQuads();
-        tessellator.setColorOpaque_I(0xffffff);
-        tessellator.addVertexWithUV(0.0D, this.gameWindow.getHeightPixels(), 0.0D, 0.0D, 0.0D);
-        tessellator.addVertexWithUV(this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels(), 0.0D, 0.0D, 0.0D);
-        tessellator.addVertexWithUV(this.gameWindow.getWidthPixels(), 0.0D, 0.0D, 0.0D, 0.0D);
-        tessellator.addVertexWithUV(0.0D, 0.0D, 0.0D, 0.0D, 0.0D);
-        tessellator.draw();
+        TessellatorGeneral t = GLRenderer.getTessellator();
+        t.startDrawingQuads();
+        t.setColorOpaque1i(0xffffff);
+        t.addVertex(0.0D, this.gameWindow.getHeightPixels(), 0.0D);
+        t.addVertex(0.0D, 0.0D, 0.0D);
+        t.addVertex(this.gameWindow.getWidthPixels(), 0.0D, 0.0D);
+        t.addVertex(this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels(), 0.0D);
+        t.draw();
 
         int width = 256;
         int height = 256;
 
-        glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
 
-        drawMojangLogoVertices((this.resolution.getScaledWidthScreenCoords() - width) / 2, (this.resolution.getScaledHeightScreenCoords() - height) / 2, 0, 0, width, height);
+        drawMojangLogoVertices(t, (this.resolution.getScaledWidthScreenCoords() - width) / 2, (this.resolution.getScaledHeightScreenCoords() - height) / 2, 0, 0, width, height);
 
-        glDisable(GL11.GL_LIGHTING);
-        glDisable(GL11.GL_FOG);
-        glEnable(GL11.GL_ALPHA_TEST);
-        glAlphaFunc(GL_GREATER, 0.1F);
+//        glDisable(GL11.GL_LIGHTING);
+//        glDisable(GL11.GL_FOG);
+//        glEnable(GL11.GL_ALPHA_TEST);
+//        glAlphaFunc(GL_GREATER, 0.1F);
         this.gameWindow.update();
     }
 
-    public void drawMojangLogoVertices(int minX, int minY, int minU, int minV, int width, int height) {
+    public void drawMojangLogoVertices(@NotNull TessellatorGeneral t, int minX, int minY, int minU, int minV, int width, int height) {
         float scaleX = 0.00390625F;
         float scaleY = 0.00390625F;
-        Tessellator tessellator = Tessellator.instance;
-        tessellator.startDrawingQuads();
-        tessellator.setColorOpaque_I(0xffffff);
-        tessellator.addVertexWithUV(minX, minY + height, 0.0D, (float) (minU) * scaleX, (float) (minV + height) * scaleY);
-        tessellator.addVertexWithUV(minX + width, minY + height, 0.0D, (float) (minU + width) * scaleX, (float) (minV + height) * scaleY);
-        tessellator.addVertexWithUV(minX + width, minY, 0.0D, (float) (minU + width) * scaleX, (float) (minV) * scaleY);
-        tessellator.addVertexWithUV(minX, minY, 0.0D, (float) (minU) * scaleX, (float) (minV) * scaleY);
-        tessellator.draw();
+        t.startDrawingQuads();
+        t.setColorOpaque1i(0xffffff);
+        t.addVertexWithUV(minX, minY + height, 0.0D, (float) (minU) * scaleX, (float) (minV + height) * scaleY);
+        t.addVertexWithUV(minX, minY, 0.0D, (float) (minU) * scaleX, (float) (minV) * scaleY);
+        t.addVertexWithUV(minX + width, minY, 0.0D, (float) (minU + width) * scaleX, (float) (minV) * scaleY);
+        t.addVertexWithUV(minX + width, minY + height, 0.0D, (float) (minU + width) * scaleX, (float) (minV + height) * scaleY);
+        t.draw();
     }
 
     public File getMinecraftDir() {
@@ -890,16 +877,7 @@ public class Minecraft
         return this.saveFormat;
     }
 
-    private Screen lastScreen;
-
     public void displayScreen(@Nullable Screen screen) {
-        // Big sir's mouse fix, clearly the legacy lwjgl dependency is fucked in some way, may we hopefully fully replace it one day
-        if (screen == null && this.lastScreen != null) {
-            Mouse.setGrabbed(false);
-            Mouse.setGrabbed(true);
-        }
-        this.lastScreen = screen;
-
         if (this.currentScreen == null && screen != null) {
             if (this.controllerInput != null) {
                 this.controllerInput.cursorX = this.resolution.getScaledWidthScreenCoords() / 2D;
@@ -1004,8 +982,8 @@ public class Minecraft
 
                     Debug.pop();            // 2
                     Debug.change("tick");    // 1
-                    if (this.currentWorld instanceof WorldClientMP) {
-                        ((WorldClientMP) this.currentWorld).processPackets();
+                    if (this.currentWorld instanceof WorldClientMP clientMP) {
+                        clientMP.processPackets();
                     }
 
                     if (this.currentScreen instanceof ScreenSelectServer) {
@@ -1033,7 +1011,7 @@ public class Minecraft
                     EntityItem.enableItemClumping = this.gameSettings.enableItemClumping.value;
                     BlockLogicLeavesBase.enableTreeShadowing = this.gameSettings.treeShadows.value;
                     this.sndManager.updateListener(this.thePlayer, this.timer.partialTicks);
-                    glEnable(GL_TEXTURE_2D);
+//                    glEnable(GL_TEXTURE_2D);
                     if (this.currentWorld != null) {
                         Debug.change("updatelight");
                         try {
@@ -1058,7 +1036,7 @@ public class Minecraft
                     Debug.push("post"); // 3
 
                     this.renderer.beginRenderGame(this.timer.partialTicks);
-                    glEnable(GL_ALPHA_TEST);
+//                    glEnable(GL_ALPHA_TEST);
 
                     Debug.change("misc");  // 3
                     if (!this.skipRenderWorld) {
@@ -1153,8 +1131,8 @@ public class Minecraft
                             while (currentSleep < sleepTime - 1) {
                                 Thread.sleep(1L);
                                 currentSleep += 1L;
-                                if (this.currentWorld instanceof WorldClientMP) {
-                                    ((WorldClientMP) this.currentWorld).processPackets();
+                                if (this.currentWorld instanceof WorldClientMP worldClientMP) {
+                                    worldClientMP.processPackets();
                                 }
 
                                 if (this.currentScreen instanceof ScreenSelectServer) {
@@ -1198,10 +1176,6 @@ public class Minecraft
     }
 
     public void freeUpMemory() {
-        try {
-            this.renderGlobal.deleteChunkLists();
-        } catch (Throwable ignored) {
-        }
         try {
             System.gc();
             ObjectPool.freeAllPools();
@@ -1224,13 +1198,11 @@ public class Minecraft
 
                 Debug.push("screenshot");
                 if (ctrl) {
-                    if (Shaders.enableShaders) {
-                        try {
-                            this.screenshotHelper.takePanoramaScreenshot();
-                            this.hudIngame.addChatMessage("Saved panorama screenshot!");
-                        } catch (Exception e) {
-                            LOGGER.error("Exception occurred while taking panoramic screenshot!", e);
-                        }
+                    try {
+                        this.screenshotHelper.takePanoramaScreenshot();
+                        this.hudIngame.addChatMessage("Saved panorama screenshot!");
+                    } catch (Exception e) {
+                        LOGGER.error("Exception occurred while taking panoramic screenshot!", e);
                     }
                 } else {
                     this.hudIngame.addChatMessage(ScreenShot.saveScreenshot(getMinecraftDir(), this.gameWindow.getWidthPixels(), this.gameWindow.getHeightPixels()));
@@ -1461,7 +1433,7 @@ public class Minecraft
             this.playerController.tick();
         }
         Debug.change("textureTick");
-        TextureRegistry.blockAtlas.bind();
+        TextureRegistry.worldAtlas.bind();
         this.textureManager.updateDynamicTextures(this.isGamePaused && this.currentScreen instanceof ScreenPause);
         Debug.change("misc");
         if (this.currentScreen == null && this.thePlayer != null) {
@@ -1601,28 +1573,20 @@ public class Minecraft
                                     PlayerProfile profile = queue.getPlayer(this.thePlayer.username);
                                     if (profile != null && profile.isOperator) {
                                         this.fullbright = !this.fullbright;
-                                        if (!LightmapHelper.isLightmapEnabled()) {
-                                            this.renderGlobal.allChanged();
-                                        }
                                     }
                                 } else {
                                     if (this.currentWorld.getLevelData().getCheatsEnabled()) {
                                         this.fullbright = !this.fullbright;
-                                        if (!LightmapHelper.isLightmapEnabled()) {
-                                            this.renderGlobal.allChanged();
-                                        }
                                     }
                                 }
                                 this.hudIngame.heldItemTooltipElement.setString("Fullbright: " + (this.fullbright ? "On" : "Off"));
                             } else if (this.gameSettings.keyLightmaps.isPressEvent()) {
-                                if (this.gameSettings.lightmapStyle.value == LightmapStyle.DISABLED) {
+                                if (this.gameSettings.lightmapStyle.value == LightmapStyle.COLORIZED) {
                                     this.gameSettings.lightmapStyle.value = LightmapStyle.GRAY;
-                                    this.hudIngame.heldItemTooltipElement.setString("Lightmap: On");
-                                    this.renderGlobal.allChanged();
+                                    this.hudIngame.heldItemTooltipElement.setString("Lightmap: Gray");
                                 } else {
-                                    this.gameSettings.lightmapStyle.value = LightmapStyle.DISABLED;
-                                    this.hudIngame.heldItemTooltipElement.setString("Lightmap: Off");
-                                    this.renderGlobal.allChanged();
+                                    this.gameSettings.lightmapStyle.value = LightmapStyle.COLORIZED;
+                                    this.hudIngame.heldItemTooltipElement.setString("Lightmap: Colored");
                                 }
                             } else if (this.gameSettings.keyCollisionBoxes.isPressEvent()) {
                                 this.gameSettings.showCollisionBoxes.toggle();
@@ -2095,6 +2059,7 @@ public class Minecraft
         this.sndManager.init(this.gameSettings);
         this.texturePackList.refresh();
         this.renderer.reload();
+        Shaders.reload();
         if (this.renderGlobal != null) {
             this.renderGlobal.allChanged();
         }
@@ -2281,9 +2246,6 @@ public class Minecraft
                 this.playerController.initPlayer(this.thePlayer);
             }
             this.thePlayer.input = new PlayerInput(this);
-            if (this.renderGlobal != null) {
-                this.renderGlobal.setWorld(world);
-            }
             if (this.particleEngine != null) {
                 this.particleEngine.setWorld(world);
             }
@@ -2298,6 +2260,9 @@ public class Minecraft
             }
             this.activeCamera = new EntityCameraFirstPerson(this, this.thePlayer);
             this.thePlayer.syncPlacementMode();
+            if (this.renderGlobal != null) {
+                this.renderGlobal.setWorld(world);
+            }
         } else {
             this.thePlayer = null;
         }
